<?php

/**
 * SecureTrading STPP Shopping Carts
 * Abantecart 0.9.1
 * Module Version 2.5.7
 * Last Updated 13 March 2013
 * Written by Peter Barrow for SecureTrading Ltd.
 * http://www.securetrading.com
 */

?><?php
 
if ( !defined ( 'DIR_CORE' )) {
	header ( 'Location: static_pages/' );
}

require_once(DIR_EXT . 'default_securetrading_stapi/securetrading_stpp/STPPLoader.php');
require_once(DIR_EXT . 'default_securetrading_stapi/AbanteSTAPI.class.php');

class ControllerResponsesExtensionDefaultSecuretradingStapi extends AController {

	/**
	 * Prepares the credit card form for display:
	 */
	public function main() {
		$this->loadLanguage('default_securetrading_stapi/default_securetrading_stapi');
		
		$template_data['text_credit_card'] = $this->language->get('text_credit_card');
		$template_data['text_wait'] = $this->language->get('text_wait');
		
		$template_data['entry_cc_type'] = $this->language->get('entry_cc_type');
		$template_data['entry_cc_number'] = $this->language->get('entry_cc_number');
		$template_data['entry_cc_expire_date'] = $this->language->get('entry_cc_expire_date');
		$template_data['entry_cc_cvv2'] = $this->language->get('entry_cc_cvv2');
		
		$template_data['button_confirm'] = $this->language->get('button_confirm');
		$template_data['button_back'] = $this->language->get('button_back');
		
		$template_data['months'] = AbanteSTAPI::createExpiryMonths();
		$template_data['years'] = AbanteSTAPI::createExpiryYears();
		
		$allCardsArray = AbanteSTAPI::getCardsArray();
		$acceptedCardsArray = explode(',', strtoupper(preg_replace('/\s/', '', $this->config->get('default_securetrading_stapi_accepted_cards'))));
		$cardString = '';
		
		foreach($acceptedCardsArray as $value) {
			if (array_key_exists($value, $allCardsArray)) {
				$cardString .= "<option value='{$value}'>{$allCardsArray[$value]}</option>";
			}
		}
		
		$template_data['cards'] = $cardString;
		
		if ($this->request->get['rt'] != 'checkout/guest_step_3') {
			$template_data['back'] = $this->html->getSecureURL('checkout/payment');
		} else {
			$template_data['back'] = $this->html->getSecureURL('checkout/guest_step_2');
		}
		
		$this->view->batchAssign( $template_data );
		$this->processTemplate('responses/default_securetrading_stapi.tpl' );
	}
	
	/**
	 * Sends order data to the gateway:
	 */
	public function send() {
		
		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		
		$requestObject = new stdClass;
		
		$requestObject->sitereference = $this->config->get('default_securetrading_stapi_site_reference');
		$requestObject->alias = $this->config->get('default_securetrading_stapi_alias');
		$requestObject->currencycode = $order_info['currency'];
		$requestObject->amount = AbanteSTAPI::formatPrice($order_info['total'], $order_info['currency']);
		$requestObject->accounttypedescription = "ECOM";
		
		$requestObject->billingprefixname = '';
		$requestObject->billingfirstname = $order_info['payment_firstname'];
		$requestObject->billinglastname = $order_info['payment_lastname'];
		$requestObject->billingtelephonetype = 'H';
		$requestObject->billingtelephone = $order_info['telephone'];
		$requestObject->billingemail = $order_info['email'];
		
		$requestObject->billingpremise = $order_info['payment_address_1'];
		$requestObject->billingstreet = $order_info['payment_address_2'];
		$requestObject->billingtown = $order_info['payment_city'];
		$requestObject->billingcounty = $order_info['payment_zone_code'];
		$requestObject->billingpostcode = $order_info['payment_postcode'];
		$requestObject->billingcountryiso2a = $order_info['payment_iso_code_2'];
		
		$requestObject->customerpremise = $order_info['shipping_firstname'];
		$requestObject->customerstreet = $order_info['shipping_lastname'];
		$requestObject->customertown = $order_info['shipping_city'];
		$requestObject->customercounty = $order_info['shipping_zone_code'];
		$requestObject->customerpostcode = $order_info['shipping_postcode'];
		$requestObject->customercountryiso2a = $order_info['shipping_iso_code_2'];
		
		$requestObject->settleduedate = $this->config->get('default_securetrading_stapi_settle_due_date');
		$requestObject->settlestatus = $this->config->get('default_securetrading_stapi_settle_status');
		
		$requestObject->orderreference = $order_info['order_id'];
		$requestObject->ip = $order_info['ip'];
		
		$requestObject->paymenttype = $_POST['cc_type'];
		$requestObject->pan = $_POST['cc_number'];
		$requestObject->expirydate = $_POST['cc_expire_date_month'] . '/' . $_POST['cc_expire_date_year'];
		$requestObject->securitycode = $_POST['cc_cvv2'];

		$requestObject->termurl = HTTP_SERVER . INDEX_FILE . '?rt=extension/default_securetrading_stapi/threedcallback';
		
		unset($_POST['cc_type'], $_POST['cc_number'], $_POST['cc_expire_date_month'], $_POST['cc_expire_date_year'], $_POST['cc_ccv2']);
		
		$stapi = new AbanteSTAPI();
		$this->setParams($stapi, TRUE); // Second param tells the module with are in the (AJAX) checkout.  This will cause the error handling to act differently to the usual header() and exit call.
		$stapi->setConnection($this->config->get('default_securetrading_stapi_host'), $this->config->get('default_securetrading_stapi_port'));
		$response = $stapi->runSTAPI($requestObject, $this->config->get('default_securetrading_stapi_use_3d_secure'));
		
		if (isset($_SESSION['securetrading_3ds_info'])) {
			$json['threedsecure'] = HTTP_SERVER . INDEX_FILE . '?rt=extension/default_securetrading_stapi/acsredirect';
		}
		elseif($response === FALSE) {
			$json['error'] = $_SESSION['securetrading_err_message'];
		}
		else {
			$json['success'] = HTTP_SERVER . INDEX_FILE . '?rt=checkout/success';
		}
		
		$this->load->library('json');
		$this->response->setOutput(AJson::encode($json));
	}
	
	/**
	 * self::send() may returns a URL to this method in $json['threedsecure'].  Accessed via Accessed via <abante_root_dir>/index.php?rt=extension/default_securetrading_stapi/acsredirect
	 */
	public function acsredirect() {
	
		$stapi = new AbanteSTAPI();
		$this->setParams($stapi);
		
		if (!isset($_SESSION['securetrading_3ds_info']) || !isset($_SESSION['securetrading_3ds_info']['acsurl']) || !isset($_SESSION['securetrading_3ds_info']['pareq']) || !isset($_SESSION['securetrading_3ds_info']['termurl']) || !isset($_SESSION['securetrading_3ds_info']['md'])) {
			$stapi->createException(new Exception('The required ACS information does not existing in the session.'), __CLASS__, __FILE__, __LINE__);
		}
		
		$acsurl = $_SESSION['securetrading_3ds_info']['acsurl'];
		$pareq = $_SESSION['securetrading_3ds_info']['pareq'];
		$termurl = $_SESSION['securetrading_3ds_info']['termurl'];
		$md = $_SESSION['securetrading_3ds_info']['md'];
		
		unset($_SESSION['securetrading_3ds_info']);
		
		$stapi->displayAcsRedirectForm($acsurl, $pareq, $termurl, $md);
	}
	
	/**
	 * 3D Secure callback.  Accessed via <abante_root_dir>/index.php?rt=extension/default_securetrading_stapi/threedcallback
	 */
	public function threedcallback() {
		
		$this->load->model('checkout/order');
		
		$stapi = new AbanteSTAPI();
		$this->setParams($stapi);
		$stapi->setConnection($this->config->get('default_securetrading_stapi_host'), $this->config->get('default_securetrading_stapi_port'));
		$result = $stapi->run3dCallback($this->config->get('default_securetrading_stapi_alias'), FALSE);

		if ($result === TRUE) {
			header("Location: " . HTTP_SERVER . INDEX_FILE . '?rt=checkout/success');
			exit;
		}
	}
	
	/**
	 * Facade method.  Sets order statuses and model to STAPI object.  Used by self::send() and self::threedcallback().
	 */
	private function setParams(&$stapi, $checkout = FALSE) {
		
		$this->load->model('extension/default_securetrading_stapi');
		
		$stapi->callbackParams = $stapi->paymentParams = $stapi->errorParams = array(
			'model' => &$this->model_checkout_order,
			'st_model' => &$this->model_extension_default_securetrading_stapi,
			'successful_order_status_id' => $this->config->get('default_securetrading_stapi_successful_order_status_id'),
			'declined_order_status_id' => $this->config->get('default_securetrading_stapi_declined_order_status_id'),
			'failed_order_status_id' => $this->config->get('default_securetrading_stapi_failed_order_status_id'),
			'checkout' => $checkout ? TRUE : FALSE,
		);
	}
}
?>